#include "LabFrameFIR.h"


#define N 401		    // number of filter coefficients
section("L1_data_b") fract16 coefs[N] = {
#include "bp_fract16.dat"
};

fract16 section("L1_data_a") input[N];
fract16 output[N];
int i = 0;		

//--------------------------------------------------------------------------//
// Function:	Process_Data()												//
//																			//
// Description: This function is called from inside the SPORT0 ISR every 	//
//				time a complete audio frame has been received. The new 		//
//				input samples can be found in the variables iChannel0LeftIn,//
//				iChannel0RightIn, iChannel1LeftIn and iChannel1RightIn 		//
//				respectively. The processed	data should be stored in 		//
//				iChannel0LeftOut, iChannel0RightOut, iChannel1LeftOut,		//
//				iChannel1RightOut, iChannel2LeftOut and	iChannel2RightOut	//
//				respectively.												//
//--------------------------------------------------------------------------//
void Process_Data(void)
{	iChannel0LeftOut = iChannel0RightIn;	
				
	input[i] = iChannel0RightIn >> 8;	
				
	int j;
	int ix = i;
	fract16 out = 0;
			
	// Filter loop
	for (j=0;j<N;j++){
		
		out = add_fr1x16(out,mult_fr1x16(input[ix++%N],coefs[j])); 
	
	}
		
	output[i] = out;
	
	i--;
	
	if (i<0)
	{
		i = N-1;
	}
	
	iChannel0RightOut = out <<8;					
}

